<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

// my_esp8266 плагин для MaxSite CMS
// файл, принимающий POST

$return = array(
	'error_code' => 1,
	'error_description' => t('Error'),
	'resp' => ''
);
$i=0; // счетчик добавленных сигналов сенсоров

/* 
Получаем сообщения о состоянии сенсоров в виде

secret - ключ доступа
name - имя платы-отправителя
ip - ip платы-отправителя
mac - mac платы
date - дата или uptime, переданные отправителем
ram - свободная память
rssi - уровень сигнала

остальные поя воспринимаются, как значения датчиков 'sensor' => 'signal'

*/
$options = mso_get_option('plugin_my_esp8266', 'plugins', array() ); // получаем опции


if ( isset($options['debug']) and $options['debug']) // запоминаем последнее обращение
{
	$post=array();
	$post['cur_time'] = date("m.d.y H:i:s", time());	
	if (isset($_POST)) $post['post'] = $_POST;
	if (isset($_SERVER)) $post['server'] = $_SERVER;	
	$last = array('last_post'=>$post);
	mso_add_option('plugin_my_esp8266_debug', $last, 'plugins' );
}

if( isset( $_POST['secret']) && isset($_POST['name']) )
{
	
	if (!isset($options['secret'])) $options['secret']='0000';
	if (!isset($options['names'])) $options['names']='esp8266';
	
	// Проверим secret		
	if( isset($options['if_secret']) and $options['if_secret'] and ($options['secret'] != $_POST['secret']) )
	{
		$return['error_code'] = 2;
		$return['error_description'] = 'Secret';
	}	
	// проверим разрешенность
	elseif ( isset($options['only_names']) and $options['only_names'] and ($options['names'] != $_POST['name']) )
	{
		$return['error_code'] = 3;
		$return['error_description'] = 'Uncnow';		
	}	
	else // все в порядке - добавляем
	{
	    require(getinfo('plugins_dir') . 'my_esp8266/functions.php'); // Функции

		$CI = &get_instance();
	    $host = @gethostbyaddr($_SERVER['REMOTE_ADDR']);
	    if( empty($host) ) $host = $_SERVER['REMOTE_ADDR'];
	    $ip_s = ip2long($_SERVER['REMOTE_ADDR']);
		
		$array_keys = array('secret','name','ip','mac','date','ram','rssi'); // служебные ключи в POST
		
		// подготовим информацию об устройстве
		$signal = array(
            'name' =>   $_POST['name'],
            'ip' =>     isset($_POST['ip']) ? $_POST['ip'] : '',
            'mac' =>    isset($_POST['mac']) ? $_POST['mac'] : '',
            'date' =>   isset($_POST['date']) ? $_POST['date'] : '',
            'ram' =>    isset($_POST['ram']) ? $_POST['ram'] : '',
            'rssi'=>    isset($_POST['rssi']) ? $_POST['rssi'] : '',
            'ip_s'	=>  $ip_s,
            'date_s' =>	time()		
		);
		
        // заносить ли name в mac, если mac не указан
        if (isset($options['name_to_mac']) and $options['name_to_mac'] and !isset($_POST['mac'])) $signal['mac']=$_POST['name'];		
		
		// добавим устройство или найдем по mac и возвратим его id
		$shield_id = esp_add_shield($signal);
		
		// теперь добавим все что в $_POST может считаться датчиками
		if ($shield_id) 
		{	
			foreach( $_POST as $sensor => $value ) 
		    {
			   if (!in_array($sensor, $array_keys)) // если не служебный ключ в $_POST, то это датчик
		       {  
		          // добавим датчик или найдем по имени и возвратим его id		
			      $sensor_id = esp_add_sensor($sensor, $shield_id);
			    
				  if ($sensor_id)
				  {
		            // заносим значение датчика (сигнал сенсора)
		            if (esp_add_signal($sensor_id, $signal, $value) )
					{
					   $i++;
					}	
				  }   
	            }
			   
	        }
			$return['error_code'] = 0;
		    $return['error_description'] = '';
		    $return['resp'] = $i;// возвращаем кол-во добавленных сигналов
	    }	
		else
		{	
		  $return['error_code'] = 4;
		  $return['error_description'] = 'DB';
		  $return['resp'] = '';
		} 
    } 
	
}
else{
		$return['error_code'] = 5;
		$return['error_description'] = 'Post';	
}

echo json_encode($return);	



