<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
// my_esp8266 плагин для MaxSite CMS
// функции работы с БД

// добавим или найдем устройство
function esp_add_shield($signal=array())
{
  $CI = & get_instance();	
  // найдем в таблице устройств устройство с таким mac
  
  $CI->db->select('shield_id');
  $CI->db->where('mac', $signal['mac']);
  $query = $CI->db->get('esp_shields');
  if ( ($query) and ($query->num_rows() > 0) ) 
  {	  
	$row = $query->row_array(1);
    return $row['shield_id'];	
  }		  
  else
  {
	$ins_data = array(
	        'name' =>   $signal['name'],
			'shield_title' =>  $signal['name'],
            'ip' =>     $signal['ip'],
            'mac' =>    $signal['mac'],
            'ram' =>    $signal['ram'],
            'rssi'=>    $signal['rssi'],
            'ip_s'	=>  $signal['ip_s'],
			'create' => time(),
			'count_signals' => 1,
			'count_sensors' => 1,
			'registered' => 0,
			'valid' => 0,
			'model' => '',
			'type' => 1,
			'desc' => '',
    );
	
    $res = ($CI->db->insert('esp_shields', $ins_data)) ? '1' : '0';
    if ($res)
		return ( $CI->db->insert_id() ); 
	else return false; 
  }	
}	


// добавим сенсор или найдем по имени name в переменной $sensor
function esp_add_sensor($sensor, $shield_id)
{
  if (!isset($shield_id) or !$shield_id) return false;
	
  $CI = & get_instance();	
  // найдем в таблице устройств устройство с таким же именем name в такой же плате shield_id
  
  $CI->db->select('sensor_id');
  $CI->db->where('sensor', $sensor);
  $CI->db->where('shield_id', $shield_id);
  
  $query = $CI->db->get('esp_sensors');
  if ( ($query) and ($query->num_rows() > 0) ) 
  {	  
	    $row = $query->row_array(1);
        return $row['sensor_id'];	
  }		  
  else
  {
	$ins_data = array(
            'sensor' =>      $sensor,
			'sensor_title' => $sensor,
            'shield_id' => $shield_id,
			'create' => time(),
			'count_signals' => 1,
			'desc' => '',
			'type' => 1,
			'model' => '',
			'registered' => 0,
			'valid' => 0
    );	
	
    $res = ($CI->db->insert('esp_sensors', $ins_data)) ? '1' : '0';
	
    if ($res) return $CI->db->insert_id(); 
	else return false;  
   }	
}


// заносим значение датчика (сигнал сенсора)
function esp_add_signal($sensor_id, $signal=array() , $value='')
{
  if (!isset($sensor_id) or !$sensor_id) return false;

  $CI = & get_instance();	
	
	$ins_data = array(
            'sensor_id' =>  $sensor_id,
            'ip' =>     $signal['ip'],
            'date' =>   $signal['date'],
            'ram' =>    $signal['ram'],
            'rssi'=>    $signal['rssi'],
            'ip_s'	=>  $signal['ip_s'],
            'date_s' =>	$signal['date_s'],
			'value' => $value
    );	
	
    $res = ($CI->db->insert('esp_signals', $ins_data)) ? '1' : '0';
    
	if ($res) return true; 
	else return false; 
}	
	
function get_signals($par, $shield_id=0, $sensor_id=0)
{
    $CI = & get_instance();
    $CI->db->select('esp_signals.*, esp_sensors.sensor, esp_sensors.sensor_id, esp_shields.name, esp_shields.mac, esp_shields.shield_id');
	$CI->db->join('esp_sensors', 'esp_sensors.sensor_id = esp_signals.sensor_id');
	$CI->db->join('esp_shields', 'esp_shields.shield_id = esp_sensors.shield_id');

	if ($shield_id) $CI->db->where('esp_sensors.shield_id', $shield_id);
	if ($sensor_id) $CI->db->where('esp_signals.sensor_id', $sensor_id);
	
    // сортировка ?
    if ( isset($par['sort_field']) )
    {
       if (!isset($par['sort_order'])) $par['sort_order'] = 'desc';
	     $CI->db->order_by($par['sort_field'] , $par['sort_order']);
    }
	if (isset($par['count'])) $CI->db->limit($par['count']);
	
	$query = $CI->db->get('esp_signals');
	
    if ( ($query) and ($query->num_rows() > 0) ) 
	     return $query->result_array(); 
	else return array();
}
	
# End of file
