<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * MaxSite CMS
 * Плагин регистрации сигналов
**/

# функция автоподключения плагина
function my_esp8266_autoload($args = array())
{

	if( is_type('admin') )
	{
		// хук на админку
		mso_hook_add('admin_init','my_esp8266_init');
	}
	
	// Хук в <head></head>
	mso_hook_add('head', 'my_esp8266_head');
	mso_hook_add('custom_page_404', 'my_esp8266_monitoring_404'); # По какому адресу будем показывать архив
}

function my_esp8266_head($args = array()){

}

# функция выполняется при активации (вкл) плагина
function my_esp8266_activate($args = array()){
	mso_create_allow('my_esp8266_edit','Админ-доступ к my_esp8266','plugins');
	
	require(getinfo('plugins_dir') . 'my_esp8266/install.php');
	
	my_esp8266_install();
	my_esp8266_add_options();
	
	return $args;
}

# функция выполняется при деактивации (выкл) плагина
function my_esp8266_deactivate($args = array()){
	// ничего не трогаем при деактивации
	return $args;
}

# функция выполняется при деинстяляции плагина
function my_esp8266_uninstall($args = array()){
	
	$CI = &get_instance();
	$CI->load->dbforge();
	
	// Удаляем таблицы
	$CI->dbforge->drop_table('esp_signals');
	$CI->dbforge->drop_table('esp_sensors');
	$CI->dbforge->drop_table('esp_shields');
	
    mso_delete_option('plugin_my_esp8266', 'plugins' ); // удалим созданные опции
    mso_delete_option('plugin_my_esp8266_debug', 'plugins' ); // удалим отладочную информацию
	
	return $args;
}

# функция выполняется при указаном хуке admin_init
function my_esp8266_init($args = array()){
	
	if( !mso_check_allow('my_esp8266_edit') ){
		return $args;
	}
	$this_plugin_url = 'my_esp8266';

	mso_admin_menu_add('plugins',$this_plugin_url,t('My_esp8266'));
	mso_admin_url_hook($this_plugin_url, 'my_esp8266_admin_page');
	
	return $args;
}

# функция вызываемая при хуке, указанном в mso_admin_url_hook
function my_esp8266_admin_page($args = array()){
	# выносим админские функции отдельно в файл	
	if( !mso_check_allow('my_esp8266_edit') ){
		echo t('Доступ запрещен');
		return $args;
	}
	
	mso_hook_add_dinamic('mso_admin_header',' return $args . "' . t('Ренистрация сигналов') . '"; ' );
	mso_hook_add_dinamic('admin_title',' return "' . t('Ренистрация сигналов') . ' - " . $args; ' );
	
	require(getinfo('plugins_dir') . 'my_esp8266/admin.php');
}


function my_esp8266_monitoring_404($args = array())
{
	$archive_url = mso_get_option('plugin_my_esp8266', 'plugins', array('out_url'=>'monitoring'));
	if (mso_segment(1) == $archive_url['out_url'])
	{
		$error = false;
		if ($fn = mso_find_ts_file('main/main-start.php')) require($fn);
		require(getinfo('plugins_dir') . 'my_esp8266/templates/default/out_signals.php');
		if ($fn = mso_find_ts_file('main/main-end.php')) require($fn);
		
		# по хуку custom_page_404 нужно возвращать true, если не требуется обработка по page_404
		if (!$error)return true; 
	}
	return $args; 
}





# End of file
