<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

// my_esp8266 плагин для MaxSite CMS
// для инсталяции

function my_esp8266_install_table($table,$fields,$primary){
	
	$CI = &get_instance();
	$CI->load->dbforge();
	
	// Удаляем таблицу
	$CI->dbforge->drop_table($table);
	
	// Добавляем поля
	$CI->dbforge->add_field($fields);
	
	// Указываем PRIMARY KEY
	if ($primary) $CI->dbforge->add_key($primary,TRUE);
	
	// Создаем таблицу
	$CI->dbforge->create_table($table);
}

function my_esp8266_install(){

	$CI = &get_instance();
	$CI->load->dbforge();
	
	// Таблица "Платы"
	if(!$CI->db->table_exists("esp_shields"))
	{
		/*
           id - id платы-отправителя
		   name - имя платы
		   mac - mac адрес платы
           ip - ip платы-отправителя
           date - дата клиента
           ram - свободная память
           rssi - уровень сигнала	
		   ip_s - ip - определенное на сервере
		   date_s - время сервера
		   create - дата создания
		   count_signals - сколько сигналов передано
		   count_sensors -сколько сенсоров имеет
		   desc - описание
		   type -  - тип int(предполагается что будет таблица типов плат)
		   model - модель
		   shield_title -  - заголовок для подписи при выводе
		   registered - плата зарегистрированна
		   valid - плата проверена
        */
		
		my_esp8266_install_table('esp_shields',array(
		
			'shield_id' => array(
				'type' => 'INT',
				'constraint' => '10',
				'unsigned' => TRUE,
				'auto_increment' => TRUE
			),
				
			'name' => array(
				'type' => 'VARCHAR',
                'constraint' => '16',				
                'NULL' => FALSE,				
				'default' => ''
			),
			
			'shield_title' => array(
				'type' => 'VARCHAR',
                'constraint' => '16',				
                'NULL' => FALSE,				
				'default' => ''
			),
			
			'mac' => array(
				'type' => 'VARCHAR',
				'constraint' => '16',
				'NULL' => FALSE
			),

			'ip' => array(
				'type' => 'VARCHAR',
				'NULL' => FALSE,
				'constraint' => '25',				
				'default' => 'no'
			),
			
			'ram' => array(
				'type' => 'VARCHAR',
				'constraint' => '10'
			),
				
			'rssi' => array(
				'type' => 'VARCHAR',
				'constraint' => '10'
			),
			
			'ip_s' => array(
				'type' => 'VARCHAR',
				'constraint' => '25',
				'NULL' => FALSE,
				'default' => '0'
			),
							
			'create' => array(
				'type' => 'INT',
				'constraint' => '10',
				'NULL' => FALSE,
				'default' => '0'
			),
			
			'count_signals' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '0'			
			),
								
			'count_sensors' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '0'
			),

			'desc' => array(
				'type' => 'VARCHAR',
				'constraint' => '25'
			),

			'type' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '1'
			),

			'model' => array(
				'type' => 'VARCHAR',
				'constraint' => '16'
			),
			
			'registered' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '0'
			),	

			'valid' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '0'
			)				
		),'shield_id');
	};


	if(!$CI->db->table_exists("esp_sensors"))
	{
		/*
           sensor_id - id сенсора
		   name - имя сенсора
		   shield_id - id платы-отправителя
		   create - дата создания
		   count_signals - сколько сигналов передано
		   desc - описание
		   type - тип int(предполагается что будет таблица типов сенсоров)
		   model - модель
		   sensor_title - заголовок для подписи при выводе
		   registered - сенсор зарегистрирован
		   valid - сенсор проверен	   
        */
		
		my_esp8266_install_table('esp_sensors',array(
		
			'sensor_id' => array(
				'type' => 'INT',
				'constraint' => '10',
				'unsigned' => TRUE,
				'auto_increment' => TRUE
			),
				
			'sensor' => array(
				'type' => 'VARCHAR',
				'constraint' => '16',
                'NULL' => FALSE,				
				'default' => ''
			),
			
			'sensor_title' => array(
				'type' => 'VARCHAR',
                'constraint' => '16',				
                'NULL' => FALSE,				
				'default' => ''
			),
			
			'shield_id' => array(
				'type' => 'INT',
				'constraint' => '10',				
				'NULL' => FALSE,
				'default' => '1'
			),
								
			'create' => array(
				'type' => 'INT',
				'constraint' => '10',
				'NULL' => FALSE
			),
			
			'count_signals' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '0'				
			),
								
			'desc' => array(
				'type' => 'VARCHAR',
				'constraint' => '25'
			),

			'type' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '1'
			),

			'model' => array(
				'type' => 'VARCHAR',
				'constraint' => '16'
			),
			
			'registered' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '0'
			),	

			'valid' => array(
				'type' => 'TINYINT',
				'NULL' => FALSE,
				'default' => '0'
			)				
		),'sensor_id');
	};

	
	if(!$CI->db->table_exists("esp_signals"))
	{
		/*
           id_sensor - id сигнала (возможно не нужен)
		   ip - переданное клиентом
           date - дата переданная клиентом
           ram - свободная память
           rssi - уровень сигнала	
		   ip_s - ip - определенное на сервере
		   date_s - время сервера в момент передачи
           value - значение сенсора
        */
		
		my_esp8266_install_table('esp_signals',array(
		
			'id' => array(
				'type' => 'INT',
				'constraint' => '10',
				'unsigned' => TRUE,
				'auto_increment' => TRUE
			),			
			
			'sensor_id' => array(
				'type' => 'INT',
				'constraint' => '10',
				'unsigned' => TRUE,
                'NULL' => FALSE
			),
				
			'ip' => array(
				'type' => 'VARCHAR',
				'NULL' => FALSE,
				'constraint' => '25',				
				'default' => 'no'
			),

			'date' => array(
				'type' => 'INT',
				'constraint' => '10',
				'NULL' => FALSE
			),

			'ram' => array(
				'type' => 'VARCHAR',
				'constraint' => '10'
			),
				
			'rssi' => array(
				'type' => 'VARCHAR',
				'constraint' => '10'
			),
			
			'ip_s' => array(
				'type' => 'VARCHAR',
				'constraint' => '25',
				'NULL' => FALSE
			),
							
			'date_s' => array(
				'type' => 'INT',
				'constraint' => '10',
				'NULL' => FALSE
			),
								
			'value' => array(
				'type' => 'VARCHAR',
				'constraint' => '25'
			)		

		),'id');
	};


	
}

function my_esp8266_add_options()
{
	$options = array(
		'out_url' => 'monitoring',
		'if_secret' => 0,
		'only_registered' => 0,
		'only_names' => 0,		
		'time' => 0,
		'admin_number_records' => 50,
		'names' => 'esp8266',
		'secret' => '0000',
		'name_to_mac' => 1,
		'debug' => 0
	);
	
	mso_add_option('plugin_my_esp8266',  $options, 'plugins' );
}

?>
