<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

// my_esp8266 плагин для MaxSite CMS
// список собыий на странице админ-панели

$CI = &get_instance();

$shield_id = mso_segment(4); // 4 сегмент - id платы
$sensor_id = mso_segment(5); // 5 сегмент - id датчика

$options = mso_get_option('plugin_my_esp8266', 'plugins', array() ); // получаем опции
require(getinfo('plugins_dir') . 'my_esp8266/functions.php');

echo '<h1>' .t('Сигналы сенсоров плат.') .'</h1>';

if ($shield_id and is_numeric($shield_id)) // указана конкретная плата
{
	// получаем данные платы
    $CI->db->select('*');
    $CI->db->where('shield_id', $shield_id);
    $query = $CI->db->get('esp_shields');
    if ( ($query) and ($query->num_rows() > 0) ) 
    {	  
	  $row = $query->row_array(1);
      echo '<h2>' .'Shield: ' . $row['name'] . ' Mac: ' . $row['mac'] .'</h2>';
    }		  
    else 
    {
      echo '<h2>' . 'Плата не найдена' . '</h2>';
	  $shield_id = FALSE;
    }
}	

if ($sensor_id and is_numeric($sensor_id)) // указан конкретный сенсор
{
	// получаем данные сенсора
    $CI->db->select('*');
    $CI->db->where('sensor_id', $sensor_id);
    $query = $CI->db->get('esp_sensors');
    if ( ($query) and ($query->num_rows() > 0) ) 
    {	  
	  $row = $query->row_array(1);
      echo '<h2>' .'Sensor: ' . $row['sensor'] . '</h2>';
    }		  
    else 
    {
      echo '<h2>' . 'Сенсор не найден' . '</h2>';
	  $sensor_id = FALSE;
    }
}	


$signals = get_signals(array('sort_field'=>'date_s', 'count'=>$options['admin_number_records']),$shield_id,$sensor_id);

if($signals)
{
	// Таблица
	$CI->load->library('table');
	$CI->table->set_template(array(
		'table_open'  => '<table class="page">',
		'table_close'=>'</table>'));
	
	// Заголовок
	$CI->table->set_heading(
		array('data'=>'Date','class'=>'list_cell_date'),
		array('data'=>'Shield','class'=>'list_cell_shield'),
		array('data'=>'Sensor','class'=>'list_cell_sensor'),
		array('data'=>'Value','class'=>'list_cell_value'),
		array('data'=>'Memory','class'=>'list_cell_ram sort'),
		array('data'=>'Rssi','class'=>'list_cell_rssi'));

	// Перебор данных
	foreach( $signals as $signal )
	{
		$cell1 = date("m.d.y H:i:s", $signal['date_s']);
		$url_shield = $plugin_url . 'list/' . $signal['shield_id'];
		$cell2 = '<a href="' . $url_shield . '">' . stripslashes($signal['name']) . '</a>';
		
		$url_sensor = $plugin_url . 'list/' . $signal['shield_id'] . '/' . $signal['sensor_id'];
		$cell3 = '<a href="' . $url_sensor. '">' . stripslashes($signal['sensor']) . '</a>';		
		
		$cell4 = stripslashes($signal['value']);
		$cell5 = stripslashes($signal['ram']);
		$cell6 = stripslashes($signal['rssi']);
		
		$CI->table->add_row($cell1,$cell2,$cell3,$cell4,$cell5,$cell6);
	}
	echo $CI->table->generate();
}
else
{
		echo '<div class="error">' .t('Ничего нет');
		echo '</div>';	
}	

?>
