<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

// my_esp8266 плагин для MaxSite CMS
// страница настроек админ-панели


if ($post = mso_check_post(array('f_session_id', 'f_submit')))
{
	$options = $_POST['plugin_my_esp8266-plugins'];

	foreach($options['_mso_checkboxs'] as $key => $val)
	{
		if(!isset($options[$key]))
			$options[$key] = 0;
	}
	unset($options['_mso_checkboxs']);
	
	$options['out_url'] = preg_replace("/[^\w-]/",'',$options['out_url']);
	$options['admin_number_records'] = (int)$options['admin_number_records'];
	$options['if_secret'] = (int)$options['if_secret'];
	$options['only_registered'] = (int)$options['only_registered'];	
	mso_add_option('plugin_my_esp8266', $options, 'plugins' );
}

$default = array(
		'out_url' => 'monitoring',
		'if_secret' => 0,
		'only_registered' => 0,
		'only_names' => 0,		
		'time' => 0,
		'admin_number_records' => 50,
		'names' => 'esp8266',
		'secret' => '0000',
		'name_to_mac' => 1,		
		'debug' => 1
);

 require(getinfo('plugins_dir') . 'my_esp8266/functions.php'); // Функции

 
// Вывод настроек
mso_admin_plugin_options('plugin_my_esp8266', 'plugins',
	array(
		'out_url' => Array
		(
			'name' => t('Ссылка на страницу датчиков '),
			'type' => 'text',
			'description' => t('Например «monitoring»'),
			'default' => $default['out_url']
		),

		'if_secret' => Array
		(
			'name' => t('Проверять наличие secret'),
			'type' => 'checkbox',
			'description' => t('Поставьте отметку если надо принимаит только с правильным ключем secret'),
			'default' => $default['if_secret']
		),

		'only_registered' => Array
		(
			'name' => t('Добавлять в базу только события зарегистрированных устройств'),
			'type' => 'checkbox',
			'description' => t('Добавлять в базу только события зарегистрированных устройств'),
			'default' => $default['only_registered']
		),
		
		'only_names' => Array
		(
			'name' => t('Добавлять в базу только события устройств с именем'),
			'type' => 'checkbox',
			'description' => t('Можно указать имена устройств'),
			'default' => $default['only_registered']
		),
		
		'name_to_mac' => Array
		(
			'name' => t('Заносить имя в поле mac-адреса'),
			'type' => 'checkbox',
			'description' => t('Если не указан mac-адрес'),
			'default' => $default['name_to_mac']
		),
		
		'admin_number_records' => Array
		(
			'name' => t('Количество событий на странице управления событиями'),
			'type' => 'text',
			'description' => t('Введите число (0 - все)'),
			'default' => $default['admin_number_records']
		),

		'names' => Array
		(
			'name' => t('Заданные имена устройств'),
			'type' => 'text',
			'description' => t('Только сигналы от этих устройств будут обрабатываться'),
			'default' => $default['names']
		),

		'secret' => Array
		(
			'name' => t('Защитный код'),
			'type' => 'text',
			'description' => t('Если указана проверка кода secret - добавлять только проходящие проверку'),
			'default' => $default['secret']
		),
		
		'debug' => Array
		(
			'name' => t('Хранить последнее обращение'),
			'type' => 'checkbox',
			'description' => t('Поставьте отметку если надо сохранять последнее обращение в файл'),
			'default' => $default['debug']
		)		
	),

	t('Настройки плагина "my_ESP8266"'),
	t('Укажите необходимые опции.'),
	''
);


?>
